$ifndef __ADCDEFS_INC
$define __ADCDEFS_INC

$ifndef _Amicus18_Rev2 ' *** Code for Revision 1 ***
'-----------------------------------------------------------
(* ***** Clock source ***** *)
$define ADC_FOSC_2       %10001111 ' A/D clock source Fosc/2
$define ADC_FOSC_4       %11001111 ' A/D clock source Fosc/4
$define ADC_FOSC_8       %10011111 ' A/D clock source Fosc/8
$define ADC_FOSC_16      %11011111 ' A/D clock source Fosc/16
$define ADC_FOSC_32      %10101111 ' A/D clock source Fosc/32
$define ADC_FOSC_64      %11101111 ' A/D clock source Fosc/64
$define ADC_FOSC_RC      %11111111 ' A/D clock source Internal RC OSC

'-----------------------------------------------------------
(* ***** Acquisition time ***** *)
$define ADC_0_TAD        %11110001
$define ADC_2_TAD        %11110011
$define ADC_4_TAD        %11110101
$define ADC_6_TAD        %11110111
$define ADC_8_TAD        %11111001
$define ADC_12_TAD       %11111011
$define ADC_16_TAD       %11111101
$define ADC_20_TAD       %11111111

'-----------------------------------------------------------
(* ***** Voltage reference ***** *)
$define ADC_REF_VDD_VREFMINUS       %01111110 ' ADC voltage source VREF+ = VDD and VREF- = ext. source at VREF-
$define ADC_REF_VREFPLUS_VREFMINUS  %01111111 ' ADC voltage source VREF+ = ext. source at VREF+ and VREF- = ext. source at VREF-
$define ADC_REF_VREFPLUS_VSS        %01111101 ' ADC voltage source VREF+ = ext. source at VREF+ and VREF- = VSS
$define ADC_REF_VDD_VSS             %01111100 ' ADC voltage source VREF+ = VDD and VREF- = VSS

'--------------------------------------------------------------

(* ***** Result justification ***** *)
$define ADC_RIGHT_JUST   %11111111 ' Right justify A/D result
$define ADC_LEFT_JUST    %01111111 ' Left justify A/D result

'--------------------------------------------------------------

$define ADC_0ANA      %0000000000000000         ' All digital
$define ADC_1ANA      %0000000000000001         ' analogue: AN0
$define ADC_2ANA      %0000000000000011         ' analogue: AN0 to AN1
$define ADC_3ANA      %0000000000000111         ' analogue: AN0 to AN2
$define ADC_4ANA      %0000000000001111         ' analogue: AN0 to AN3
$define ADC_5ANA      %0000000000011111         ' analogue: AN0 to AN4
$define ADC_6ANA      %0000000000111111         ' analogue: AN0 to AN5
$define ADC_7ANA      %0000000001111111         ' analogue: AN0 to AN6
$define ADC_8ANA      %0000000011111111         ' analogue: AN0 to AN7
$define ADC_9ANA      %0000000111111111         ' analogue: AN0 to AN8
$define ADC_10ANA     %0000001111111111         ' analogue: AN0 to AN9
$define ADC_11ANA     %0000011111111111         ' analogue: AN0 to AN10
$define ADC_12ANA     %0000111111111111         ' analogue: AN0 to AN11
$define ADC_13ANA     %0001111111111111         ' analogue: AN0 to AN12

$define ADC_0ANA_ONLY  %0000000000000000         ' All digital
$define ADC_1ANA_ONLY  %0000000000000001         ' analogue: AN0 only
$define ADC_2ANA_ONLY  %0000000000000010         ' analogue: AN1 only
$define ADC_3ANA_ONLY  %0000000000000100         ' analogue: AN2 only
$define ADC_4ANA_ONLY  %0000000000001000         ' analogue: AN3 only
$define ADC_5ANA_ONLY  %0000000000010000         ' analogue: AN4 only
$define ADC_6ANA_ONLY  %0000000000100000         ' analogue: AN5 only
$define ADC_7ANA_ONLY  %0000000001000000         ' analogue: AN6 only
$define ADC_8ANA_ONLY  %0000000010000000         ' analogue: AN7 only
$define ADC_9ANA_ONLY  %0000000100000000         ' analogue: AN8 only
$define ADC_10ANA_ONLY %0000001000000000         ' analogue: AN9 only
$define ADC_11ANA_ONLY %0000010000000000         ' analogue: AN10 only
$define ADC_12ANA_ONLY %0000100000000000         ' analogue: AN11 only
$define ADC_13ANA_ONLY %0001000000000000         ' analogue: AN12 only

'-----------------------------------------------------------
(* ***** Channel selection ***** *)
$define ADC_CH0          %00000111  ' Channel 0
$define ADC_CH1          %00001111  ' Channel 1
$define ADC_CH2          %00010111  ' Channel 2
$define ADC_CH3          %00011111  ' Channel 3
$define ADC_CH4          %00100111  ' Channel 4
$define ADC_CH5          %00101111  ' Channel 5
$define ADC_CH6          %00110111  ' Channel 6
$define ADC_CH7          %00111111  ' Channel 7
$define ADC_CH8          %01000111  ' Channel 8
$define ADC_CH9          %01001111  ' Channel 9
$define ADC_CH10         %01010111  ' Channel 10
$define ADC_CH11         %01011111  ' Channel 11
$define ADC_CH12         %01100111  ' Channel 12
$define ADC_CH13         %01101111  ' Channel 13
$define ADC_CH14         %01110111  ' Channel 14
$define ADC_CH15         %01111111  ' Channel 15

'***************************************************************
' Code for Revision 2 of the amicus18 using the 18F25K22
'***************************************************************
$else   ' *** Code for Revision 2
(* ***** Clock source ***** *)
$define ADC_FOSC_2       %10001111 ' A/D clock source Fosc/2
$define ADC_FOSC_4       %11001111 ' A/D clock source Fosc/4
$define ADC_FOSC_8       %10011111 ' A/D clock source Fosc/8
$define ADC_FOSC_16      %11011111 ' A/D clock source Fosc/16
$define ADC_FOSC_32      %10101111 ' A/D clock source Fosc/32
$define ADC_FOSC_64      %11101111 ' A/D clock source Fosc/64
$define ADC_FOSC_RC      %11111111 ' A/D clock source Internal RC OSC

'-----------------------------------------------------------
(* ***** Acquisition time ***** *)
$define ADC_0_TAD        %11110001
$define ADC_2_TAD        %11110011
$define ADC_4_TAD        %11110101
$define ADC_6_TAD        %11110111
$define ADC_8_TAD        %11111001
$define ADC_12_TAD       %11111011
$define ADC_16_TAD       %11111101
$define ADC_20_TAD       %11111111
'-----------------------------------------------------------
(* Positive Voltage Reference Configuration *)
$define _ADC_REF_VDD_VDD          0xFC     ' ADC voltage source VREF+ = AVDD
$define _ADC_REF_VDD_VREFPLUS     0xFB     ' ADC voltage source VREF+ = ext. source at VREF+
$define _ADC_REF_VDD_FVREF        0xFD     ' ADC voltage source VREF+ = FVREF+

'-----------------------------------------------------------
(* Negative Voltage Reference Configuration *)
$define _ADC_REF_VDD_VSS          0xFC     ' ADC voltage source VREF- = AVSS
$define _ADC_REF_VDD_VREFMINUS    0xFD     ' ADC voltage source VREF- = ext. source at VREF-

' Combined to make 3 parameters instead of the four required for OpenADC()
$define ADC_REF_VDD_VREFMINUS _ADC_REF_VDD_VDD,ADC_REF_VDD_VREFMINUS
$define ADC_REF_VDD_VSS _ADC_REF_VDD_VDD,_ADC_REF_VDD_VSS
$define ADC_REF_VREFPLUS_VREFMINUS _ADC_REF_VDD_VREFPLUS,_ADC_REF_VDD_VREFMINUS
$define ADC_REF_VREFPLUS_VSS _ADC_REF_VDD_VREFPLUS,_ADC_REF_VDD_VSS

'--------------------------------------------------------------
(* ***** Result justification ***** *)
$define ADC_RIGHT_JUST   %11111111 ' Right justify A/D result
$define ADC_LEFT_JUST    %01111111 ' Left justify A/D result

'-----------------------------------------------------------
(* ***** Analogue Pin Selection ***** *)
$define ADC_0ANA      0x00 '%0000000000000000         ' All digital
$define ADC_1ANA      0x01 '%0000000000000001         ' analogue: AN0
$define ADC_2ANA      0x03 '%0000000000000011         ' analogue: AN0 to AN1
$define ADC_3ANA      0x05 '%0000000000000111         ' analogue: AN0 to AN2
$define ADC_4ANA      0x07 '%0000000000001111         ' analogue: AN0 to AN3
$define ADC_5ANA      0x1F '%0000000000011111         ' analogue: AN0 to AN4

'$define ADC_6ANA      %0000000000111111         ' analogue: AN0 to AN5 (Not present)
'$define ADC_7ANA      %0000000001111111         ' analogue: AN0 to AN6 (Not present)
'$define ADC_8ANA      %0000000011111111         ' analogue: AN0 to AN7 (Not present)

$define ADC_9ANA      0x0100 '%000000000000000100000000 ' analogue: AN0 to AN8
$define ADC_10ANA     0x0300 '%000000000000001100000000 ' analogue: AN0 to AN9
$define ADC_11ANA     0x0700 '%000000000000011100000000 ' analogue: AN0 to AN10
$define ADC_12ANA     0x0F00 '%000000000000111100000000 ' analogue: AN0 to AN11
$define ADC_13ANA     0x1F00 '%000000000001111100000000 ' analogue: AN0 to AN12
$define ADC_14ANA     0x3F00 '%000000000011111100000000 ' analogue: AN0 to AN13

$define ADC_15ANA     0x010000 '%000000010000000000000000 ' analogue: AN0 to AN14
$define ADC_16ANA     0x030000 '%000000110000000000000000 ' analogue: AN0 to AN15
$define ADC_17ANA     0x070000 '%000001110000000000000000 ' analogue: AN0 to AN16
$define ADC_18ANA     0x0F0000 '%000011110000000000000000 ' analogue: AN0 to AN17
$define ADC_19ANA     0x1F0000 '%000111110000000000000000 ' analogue: AN0 to AN18

'-----------------------------------------------------------
(* ***** Channel selection ***** *)
$define ADC_CH0          %00000111  ' Channel 0
$define ADC_CH1          %00001111  ' Channel 1
$define ADC_CH2          %00010111  ' Channel 2
$define ADC_CH3          %00011111  ' Channel 3
$define ADC_CH4          %00100111  ' Channel 4
'$define ADC_CH5          %00101111  ' Channel 5 (Not present)
'$define ADC_CH6          %00110111  ' Channel 6 (Not present)
'$define ADC_CH7          %00111111  ' Channel 7 (Not present)
$define ADC_CH8          %01000111  ' Channel 8
$define ADC_CH9          %01001111  ' Channel 9
$define ADC_CH10         %01010111  ' Channel 10
$define ADC_CH11         %01011111  ' Channel 11
$define ADC_CH12         %01100111  ' Channel 12
$define ADC_CH13         %01101111  ' Channel 13
$define ADC_CH14         %01110111  ' Channel 14
$define ADC_CH15         %01111111  ' Channel 15

$define ADC_CH16         %10000111  ' Channel 16
$define ADC_CH17         %10001111  ' Channel 17
$define ADC_CH18         %10010111  ' Channel 18
$define ADC_CH19         %10011111  ' Channel 19
$endif

$endif

